zoukankan      html  css  js  c++  java
  • HDU

    Problem Description
    Jack likes to travel around the world, but he doesn’t like to wait. Now, he is traveling in the Undirected Kingdom. There are n cities and m bidirectional roads connecting the cities. Jack hates waiting too long on the bus, but he can rest at every city. Jack can only stand staying on the bus for a limited time and will go berserk after that. Assuming you know the time it takes to go from one city to another and that the time Jack can stand staying on a bus is x minutes, how many pairs of city (a,b) are there that Jack can travel from city a to b without going berserk?
     
    Input
    The first line contains one integer T,T5, which represents the number of test case.
    For each test case, the first line consists of three integers n,m and q where n20000,m100000,q5000. The Undirected Kingdom has n cities and mbidirectional roads, and there are q queries.
    Each of the following m lines consists of three integers a,b and d where a,b{1,...,n} and d100000. It takes Jack d minutes to travel from city a to city b and vice versa.
    Then q lines follow. Each of them is a query consisting of an integer x where x is the time limit before Jack goes berserk.

    Output
    You should print q lines for each test case. Each of them contains one integer as the number of pair of cities (a,b) which Jack may travel from a to b within the time limit x.
    Note that (a,b) and (b,a) are counted as different pairs and a and b must be different cities.
     
    Sample Input
    1
    5 5 3
    2 3 6334
    1 5 15724
    3 5 5705
    4 3 12382
    1 3 21726
    6000
    10000
    13000
     
    Sample Output
    2
    6
    12
     

     怎么说呢,哎,在这道题上面浪费了整整一天的时间,理解题意得错误导致了这么严重的后果,简直无语了,下面这张截图,非常励志的一个故事= =

    说多了都是泪啊,主要错在了合并城市的路的条数上,我现在的心情你无法理解,呜呜呜呜呜..............

    #include<cstdio>
    #include<algorithm>
    #include<cstring>
    #include<string>
    #include<queue>
    using namespace std;
    
    #define INF 0x3f3f3f3f
    #define lsonl,m,rt<<1
    #define rsonm+1,r,rt<<1|1
    
    const int MX = 222222;
    
    int road[MX];
    int num[MX];
    
    structNode {
        int a, b, c;
    }node[MX];
    
    structQuery {
        int n, sign, ans;
    }query[MX];
    
    bool comp1(const Node& n1, const Node& n2) {
        return n1.c < n2.c;
    }
    
    bool comp2(const Query& q1, const Query& q2) {
        return q1.n < q2.n;
    }
    
    bool comp3(const Query& q1, const Query& q2) {
        return q1.sign < q2.sign;
    }
    
    int Find(int x) {
        return road[x] == x ? x : (road[x] = Find(road[x]));
    }
    
    int main() {
        //freopen("input.txt", "r", stdin);
        int n, m, q;
        int cas;
        while (scanf("%d", &cas) != EOF) {
            while (cas--) {
                scanf("%d%d%d", &n, &m, &q);
                for (int i = 0; i <= n; i++) {
                    road[i] = i;
                    num[i] = 1;
                }
                for (int i = 1; i <= m; i++) {
                    scanf("%d%d%d", &node[i].a, &node[i].b, &node[i].c);
                }
                sort(node + 1, node + m + 1, comp1);
                for (int i = 1; i <= q; i++) {
                    scanf("%d", &query[i].n);
                    query[i].sign = i;
                }
                sort(query + 1, query + 1 + q, comp2);
                int ans = 0;
                for (int i = 1, j = 1; i <= q; i++) {
                    while (j <= m && node[j].c <= query[i].n) {
                        int root1 = Find(node[j].a);
                        int root2 = Find(node[j].b);
                        j++;
                        if (root1 != root2) {
                            ans += num[root1] * num[root2] * 2;//就是这里,好难搞清楚啊,呜呜呜呜............新元素乘以老元素,这就是多出来的新路的条数,乘以二是因为a到d与b到a是两条路
                            road[root2] = root1;
                            num[root1] += num[root2];
                        }
                    }
                    query[i].ans = ans;
                }
                sort(query + 1, query + 1 + q, comp3);
                for (int i = 1; i <= q; i++) {
                    printf("%d
    ", query[i].ans);
                }
            }
        }
        return 0;
    }
  • 相关阅读:
    vue--三种组件中之间的传值
    数学log的基本知识
    通俗易懂理解——dijkstra算法求最短路径
    数据结构--Dijkstra算法最清楚的讲解
    explorer.exe
    经典树与图论(最小生成树、哈夫曼树、最短路径问题---Dijkstra算法)
    WPF路由事件二:路由事件的三种策略
    luogu P1979 华容道
    4.Linux查看文件大小的几种方法
    Pairing heap
  • 原文地址:https://www.cnblogs.com/steamedbun/p/5713032.html
Copyright © 2011-2022 走看看